Index: src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Answer/Answer.Debug.Seed.sql
===================================================================
--- src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Answer/Answer.Debug.Seed.sql	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Answer/Answer.Debug.Seed.sql	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -12,5 +12,5 @@
             (3, N'cee193c3-9d36-4ed8-81b2-15eb4ff305f1', N'Answer 3', 2, 1, 1, GETUTCDATE(), 5),
             (4, N'dee193c3-9d36-4ed8-81b2-15eb4ff305f1', N'Answer 4', 2, 1, 0, GETUTCDATE(), 5)
-    ) AS temp ([Id], [Uid], [Text], [QuestionFk], [StudentFk], [CorrectAnswer], [CreatedOn], [VotesCount])
+    ) AS temp ([Id], [Uid], [Text], [QuestionFk], [StudentFk], [CorrectAnswer], [CreatedOn], [UpvotesCount])
     ) AS S
     ON T.[ID] = S.[ID]
@@ -21,5 +21,5 @@
                    T.[StudentFk] = S.[StudentFk],
                    T.[CorrectAnswer] = S.[CorrectAnswer],
-                   T.[VotesCount] = S.[VotesCount]
+                   T.[UpvotesCount] = S.[UpvotesCount]
     WHEN NOT MATCHED THEN
         INSERT
@@ -32,8 +32,8 @@
             [CorrectAnswer],
             [CreatedOn],
-            [VotesCount]
+            [UpvotesCount]
         )
         VALUES
-        (S.[Id], S.[Uid], S.[Text], S.[QuestionFk], S.[StudentFk], S.[CorrectAnswer], S.[CreatedOn], S.[VotesCount]);
+        (S.[Id], S.[Uid], S.[Text], S.[QuestionFk], S.[StudentFk], S.[CorrectAnswer], S.[CreatedOn], S.[UpvotesCount]);
     SET IDENTITY_INSERT [dbo].[Answer] OFF
 END
Index: src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Answer/Answer.sql
===================================================================
--- src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Answer/Answer.sql	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Answer/Answer.sql	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -7,5 +7,5 @@
     [CorrectAnswer] BIT              NOT NULL,
     [CreatedOn]     SMALLDATETIME    NOT NULL,
-    [VotesCount] BIGINT NOT NULL DEFAULT 0, 
+    [UpvotesCount] BIGINT NOT NULL DEFAULT 0, 
     CONSTRAINT [PK_Answer] PRIMARY KEY CLUSTERED ([Id] ASC),
     CONSTRAINT [FK_Answer_Question_QuestionFk] FOREIGN KEY ([QuestionFk]) REFERENCES [dbo].[Question] ([Id]),
Index: src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Upvote.sql
===================================================================
--- src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Upvote.sql	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
+++ src/FinkiChattery/FinkiChattery.Database/dbo/Tables/Upvote.sql	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -0,0 +1,20 @@
+﻿CREATE TABLE [dbo].[Upvote] (
+    [Id]        BIGINT           IDENTITY (1, 1) NOT NULL,
+    [Uid]       UNIQUEIDENTIFIER NOT NULL,
+    [StudentFk] BIGINT           NOT NULL,
+    [AnswerFk]  BIGINT           NOT NULL,
+    CONSTRAINT [PK_Upvote] PRIMARY KEY CLUSTERED ([Id] ASC),
+    CONSTRAINT [FK_Upvote_Answer_AnswerFk] FOREIGN KEY ([AnswerFk]) REFERENCES [dbo].[Answer] ([Id]),
+    CONSTRAINT [FK_Upvote_Student_StudentFk] FOREIGN KEY ([StudentFk]) REFERENCES [dbo].[Student] ([Id])
+);
+
+
+GO
+CREATE NONCLUSTERED INDEX [IX_Upvote_AnswerFk]
+    ON [dbo].[Upvote]([AnswerFk] ASC);
+
+
+GO
+CREATE NONCLUSTERED INDEX [IX_Upvote_StudentFk]
+    ON [dbo].[Upvote]([StudentFk] ASC);
+
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerConfig.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/AnswerConfig.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -22,5 +22,5 @@
             builder.Property(x => x.CorrectAnswer).HasColumnName(@"CorrectAnswer").HasColumnType("bit").IsRequired();
             builder.Property(x => x.CreatedOn).HasColumnName(@"CreatedOn").HasColumnType("smalldatetime").IsRequired();
-            builder.Property(x => x.VotesCount).HasColumnName(@"VotesCount").HasColumnType("bigint").IsRequired().HasDefaultValue(0);
+            builder.Property(x => x.UpvotesCount).HasColumnName(@"UpvotesCount").HasColumnType("bigint").IsRequired().HasDefaultValue(0);
 
             builder.HasOne(x => x.Question).WithMany(x => x.Answers).HasForeignKey(x => x.QuestionFk).OnDelete(DeleteBehavior.Restrict);
Index: src/FinkiChattery/FinkiChattery.Persistence/Configurations/UpvoteConfig.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Configurations/UpvoteConfig.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
+++ src/FinkiChattery/FinkiChattery.Persistence/Configurations/UpvoteConfig.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -0,0 +1,31 @@
+﻿using Microsoft.EntityFrameworkCore;
+using Microsoft.EntityFrameworkCore.Metadata.Builders;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using FinkiChattery.Persistence.Models;
+
+namespace FinkiChattery.Persistence.Configurations
+{
+    public class UpvoteConfig : BaseConfig<Upvote>
+    {
+        public UpvoteConfig(string schema) : base(schema)
+        {
+        }
+
+        public override void Configure(EntityTypeBuilder<Upvote> builder)
+        {
+            base.Configure(builder);
+
+            builder.ToTable("Upvote", Schema);
+
+            builder.Property(x => x.StudentFk).HasColumnName(@"StudentFk").HasColumnType("bigint").IsRequired();
+            builder.Property(x => x.AnswerFk).HasColumnName(@"AnswerFk").HasColumnType("bigint").IsRequired();
+
+            builder.HasOne(x => x.Student).WithMany().HasForeignKey(x => x.StudentFk).OnDelete(DeleteBehavior.Restrict);
+            builder.HasOne(x => x.Answer).WithMany(x => x.Upvotes).HasForeignKey(x => x.AnswerFk).OnDelete(DeleteBehavior.Restrict);
+        }
+    }
+}
Index: src/FinkiChattery/FinkiChattery.Persistence/Context/ApplicationDbContext.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Context/ApplicationDbContext.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Context/ApplicationDbContext.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -23,5 +23,5 @@
         public DbSet<TeacherTeam> TeacherTeams { get; set; }
         public DbSet<Team> Teams { get; set; }
-        public DbSet<Vote> Votes { get; set; }
+        public DbSet<Upvote> Upvotes { get; set; }
 
         protected override void OnModelCreating(ModelBuilder builder)
@@ -42,5 +42,5 @@
             builder.ApplyConfiguration(new TeacherTeamConfig(schema));
             builder.ApplyConfiguration(new TeamConfig(schema));
-            builder.ApplyConfiguration(new VoteConfig(schema));
+            builder.ApplyConfiguration(new UpvoteConfig(schema));
         }
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Answer.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Answer.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Answer.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -6,11 +6,4 @@
     public class Answer : BaseEntity
     {
-        public Answer() : base()
-        {
-            CreatedOn = DateTime.UtcNow;
-            VotesCount = 0;
-            CorrectAnswer = false;
-        }
-
         public string Text { get; set; }
 
@@ -27,7 +20,7 @@
         public DateTime CreatedOn { get; set; }
 
-        public long VotesCount { get; set; }
+        public long UpvotesCount { get; set; }
 
-        public virtual ICollection<Vote> Votes { get; set; }
+        public virtual ICollection<Upvote> Upvotes { get; set; }
 
         public virtual ICollection<AnswerResponse> AnswerResponses { get; set; }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Moderator.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Moderator.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Moderator.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -1,3 +1,9 @@
-﻿namespace FinkiChattery.Persistence.Models
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace FinkiChattery.Persistence.Models
 {
     public class Moderator : BaseEntity
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Student.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Student.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Student.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -1,3 +1,7 @@
-﻿using System.Collections.Generic;
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
 
 namespace FinkiChattery.Persistence.Models
@@ -18,7 +22,7 @@
 
         public virtual ICollection<Question> Questions { get; set; }
-
+        
         public virtual ICollection<Answer> Answers { get; set; }
-
+        
         public virtual ICollection<StudentTeam> StudentTeams { get; set; }
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/Models/Upvote.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Models/Upvote.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
+++ src/FinkiChattery/FinkiChattery.Persistence/Models/Upvote.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -0,0 +1,19 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace FinkiChattery.Persistence.Models
+{
+    public class Upvote : BaseEntity
+    {
+        public long StudentFk { get; set; }
+
+        public virtual Student Student { get; set; }
+
+        public long AnswerFk { get; set; }
+
+        public virtual Answer Answer { get; set; }
+    }
+}
Index: src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/IQuestionRepo.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/IQuestionRepo.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/IQuestionRepo.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -16,8 +16,4 @@
      
         Task<List<QuestionPreviewDto>> GetPreviewQuestionsPopular();
-
-        Task<bool> QuestionIsOwnedByStudent(Guid questionUid, long applicationUserId);
-
-        Task<Question> GetQuestionWithAnswersAndStudents(Guid questionUid);
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/IStudentRepo.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/IStudentRepo.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/IStudentRepo.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -1,4 +1,3 @@
 ﻿using FinkiChattery.Persistence.Models;
-using FinkiChattery.Persistence.Repositories.Contracts;
 using System.Threading.Tasks;
 
@@ -8,5 +7,4 @@
     {
         public Task<Student> GetStudent(long applicationUserFk);
-        public Task<StudentSelfDto> GetStudentSelfDto(long applicationUserFk);
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/Question/QuestionStateDto.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/Question/QuestionStateDto.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Repositories/Contracts/Question/QuestionStateDto.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -84,5 +84,5 @@
     public class AnswerQuestionStateDto
     {
-        public AnswerQuestionStateDto(long id, Guid uid, string text, bool correctAnswer, DateTime createdOn, long votesCount, AnswerStudentQuestionStateDto studentDto, IEnumerable<AnswerResponseQuestionStateDto> answerResponsesDto)
+        public AnswerQuestionStateDto(long id, Guid uid, string text, bool correctAnswer, DateTime createdOn, long upvotesCount, AnswerStudentQuestionStateDto studentDto, IEnumerable<AnswerResponseQuestionStateDto> answerResponsesDto)
         {
             Id = id;
@@ -91,5 +91,5 @@
             CorrectAnswer = correctAnswer;
             CreatedOn = createdOn;
-            VotesCount = votesCount;
+            UpvotesCount = upvotesCount;
             StudentDto = studentDto;
             AnswerResponsesDto = answerResponsesDto;
@@ -101,5 +101,5 @@
         public bool CorrectAnswer { get; }
         public DateTime CreatedOn { get; }
-        public long VotesCount { get; }
+        public long UpvotesCount { get; }
         public AnswerStudentQuestionStateDto StudentDto { get; }
         public IEnumerable<AnswerResponseQuestionStateDto> AnswerResponsesDto { get; }
Index: src/FinkiChattery/FinkiChattery.Persistence/Repositories/Implementations/QuestionRepo.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Repositories/Implementations/QuestionRepo.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Repositories/Implementations/QuestionRepo.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -80,5 +80,5 @@
                                                     y.CorrectAnswer,
                                                     y.CreatedOn,
-                                                    y.VotesCount,
+                                                    y.UpvotesCount,
                                                     new AnswerStudentQuestionStateDto(
                                                         y.Student.Id,
@@ -144,18 +144,4 @@
                 .ToListAsync();
         }
-
-        public async Task<bool> QuestionIsOwnedByStudent(Guid questionUid, long applicationUserId)
-        {
-            return await DbSet
-                .Where(x => x.Uid == questionUid && x.Student.ApplicationUserFk == applicationUserId)
-                .AnyAsync();
-        }
-
-        public async Task<Question> GetQuestionWithAnswersAndStudents(Guid questionUid)
-        {
-            return await DbSet
-                .Include(x => x.Answers).ThenInclude(x => x.Student)
-                .FirstOrDefaultAsync(x => x.Uid == questionUid);
-        }
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/Repositories/Implementations/StudentRepo.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/Repositories/Implementations/StudentRepo.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/Repositories/Implementations/StudentRepo.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -1,7 +1,5 @@
 ﻿using FinkiChattery.Persistence.Context;
 using FinkiChattery.Persistence.Models;
-using FinkiChattery.Persistence.Repositories.Contracts;
 using Microsoft.EntityFrameworkCore;
-using System.Linq;
 using System.Threading.Tasks;
 
@@ -18,21 +16,4 @@
             return await DbSet.FirstOrDefaultAsync(x => x.ApplicationUserFk == applicationUserFk);
         }
-
-        public async Task<StudentSelfDto> GetStudentSelfDto(long applicationUserFk)
-        {
-            return await DbSet
-                .AsNoTracking()
-                .Include(x => x.Questions)
-                .Include(x => x.StudentTeams).ThenInclude(x => x.Team)
-                .Where(x => x.ApplicationUserFk == applicationUserFk)
-                .Select(x => new StudentSelfDto(x.Uid,
-                                                x.ApplicationUserFk,
-                                                x.IndexNumber,
-                                                x.Reputation,
-                                                x.ImageUrl,
-                                                x.Questions.Select(y => new StudentQuestionDto(y.Uid, y.Title)),
-                                                x.StudentTeams.Select(y => new StudentTeamDto(y.Team.Uid, y.Team.Name))))
-                .FirstOrDefaultAsync();
-        }
     }
 }
Index: src/FinkiChattery/FinkiChattery.Persistence/UnitOfWork/Contracts/IUnitOfWork.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/UnitOfWork/Contracts/IUnitOfWork.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/UnitOfWork/Contracts/IUnitOfWork.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -11,8 +11,4 @@
         IStudentRepo Students { get; }
         ITeamRepo Teams { get; }
-        IVoteRepo Votes { get; }
-        IAnswerRepo Answers { get; }
-        ITeacherRepo Teachers { get; }
-        IModeratorRepo Moderators { get; }
         Task<int> SaveAsync();
     }
Index: src/FinkiChattery/FinkiChattery.Persistence/UnitOfWork/Implementations/UnitOfWork.cs
===================================================================
--- src/FinkiChattery/FinkiChattery.Persistence/UnitOfWork/Implementations/UnitOfWork.cs	(revision 6901f8b9e6373705c4ebfc4799374f1e79f6d3e5)
+++ src/FinkiChattery/FinkiChattery.Persistence/UnitOfWork/Implementations/UnitOfWork.cs	(revision 1e0d86905c02abe14201bf07ad5a2163900a5602)
@@ -12,38 +12,8 @@
         private StudentRepo _students;
         private TeamRepo _teams;
-        private VoteRepo _votes;
-        private AnswerRepo _answers;
-        private ModeratorRepo _moderators;
-        private TeacherRepo _teachers;
 
         public UnitOfWork(ApplicationDbContext dbContext)
         {
             DbContext = dbContext;
-        }
-
-        public IModeratorRepo Moderators
-        {
-            get
-            {
-                if (_moderators == null)
-                {
-                    _moderators = new ModeratorRepo(DbContext);
-                }
-
-                return _moderators;
-            }
-        }
-
-        public ITeacherRepo Teachers
-        {
-            get
-            {
-                if (_teachers == null)
-                {
-                    _teachers = new TeacherRepo(DbContext);
-                }
-
-                return _teachers;
-            }
         }
 
@@ -100,30 +70,4 @@
         }
 
-        public IVoteRepo Votes
-        {
-            get
-            {
-                if (_votes == null)
-                {
-                    _votes = new VoteRepo(DbContext);
-                }
-
-                return _votes;
-            }
-        }
-
-        public IAnswerRepo Answers
-        {
-            get
-            {
-                if (_answers == null)
-                {
-                    _answers = new AnswerRepo(DbContext);
-                }
-
-                return _answers;
-            }
-        }
-
         public ApplicationDbContext DbContext { get; }
 
